/*********************************************
 * AUSGL.C				     *
 *-------------------------------------------*
 * Ausgleichsmethode nach Gau mit Cholesky  *
 *********************************************/
#include <stdio.h>
#include <stdlib.h>
#include "matrix.h"

#define A a->inh
#define B b->inh

main(int argc,char *argv[])
{  int i,j,s;
   int g;    /*Grad des Polynoms*/
   int rc;
   double x,y,h,*sum;
   FILE *fp;
   MATRIX a,l,lt;
   VEKTOR b,alpha,hilf;

   /*Kommandozeilenparameter auswerten */
   if(argc > 1)
   {
     g=atoi(argv[1]);
   }
   else
   {
     fprintf(stderr,"Grad des Polynoms ?");scanf("%d",&g);
   }
   if(argc > 2)
   {
      fp=fopen(argv[2],"r");
   }
   else
   {
     fp=stdin;
     fprintf(stderr,"Stellen und Werte ? (Ende Ctrl-D )\n");
   }
  
   if(fp==NULL)
   { fprintf(stderr,"Fehler beim Datei ffnen\n");
     exit(1);
   }

   if(g<1) { fprintf(stderr,"Polynomgrad nicht sinnvoll !!!!\n");exit(1);}

   /*Summenfeld einrichten*/
   sum=(double *)malloc((2*g+1)*sizeof(double));
   if(sum == NULL) {fprintf(stderr,"Kein Speicher mehr!\n");exit(1);}
   for(i=0;i<=2*g;i++) sum[i]=0;

   b=veinricht(g+1);

   /*Sttzwerte einlesen und Summen bestimmen*/
   while(fscanf(fp,"%lG %lG",&x,&y)!=EOF)
   { h=1; sum[0]++; B[0]+=y;
     for(i=1;i<=g;i++)
     { h *=x;
       sum[i]+=h;
       B[i]+=h*y;
     }
     for(i=g+1;i<=2*g;i++)
     { h *=x;
       sum[i]+=h;
     }
   }

   /* Matrix A ausrechnen*/
   a=meinricht(g+1,g+1);
   for(s=0;s<=2*g;s++)
      for(j=0;j<=s;j++)
      { if(s-j <=g && j<=g)
	  A[s-j][j]=sum[s];
      }

   /* Matrix a mit Cholesky zerlegen */
   rc=cholesky(&l,a);
   if(!rc) { fprintf(stderr,"\n Matrix lt sich nicht zerlegen!\n"); exit(1);}

   lt=mattrans(l);

   hilf=leinsetz(l,b);
   alpha=reinsetz(lt,hilf);
   fprintf(stderr,"Ergebnis:\n");
   vekaus(alpha);
}








