/************************************************************
 *  Approximation der eingegebenen Funktionswerte durch ein *
 *  Poloynom angegebenes Grades 			    *
 *  mit Qrtogonaltransformation nach Givens		    *
 ************************************************************/
#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include"matrix.h"
#include"rscanf.h"
#define DELTA 1E-15 /*kleinste Zahl mit 1+DELTA!=1*/
#define MAXL 20     /*Lnge der Arbeitszeile*/
#define R r->inh
#define D d->inh
/*Variablen*/
double arbz[MAXL];  /*Arbeitszeile */

main(int argc,char *argv[])
{  int p,q,i,j,n,m,rc;
   int g;    /*Grad des Polynoms*/
   MATRIX r;
   VEKTOR u,d;
   double h,si,co;
   double x,y;
   FILE *fp;

   /*Kommandozeilenparameter auswerten */
   if(argc > 1)
   {
     g=atoi(argv[1]);
   }
   else
   {
     fprintf(stderr,"Grad des Polynoms ?");scanf("%d",&g);
   }
   if(argc > 2)
   {
      fp=fopen(argv[2],"r");
   }
   else
   {
     fp=stdin;
     fprintf(stderr,"Stellen und Werte ? (Ende Ctrl-D )\n");
   }

   if(fp==NULL)
   { fprintf(stderr,"Fehler beim Datei ffnen\n");
     exit(1);
   }

   if(g<1) { fprintf(stderr,"Polynomgrad nicht sinnvoll !!!!\n");exit(1);}

   i=0;m=g+1;
   /*Matrix und Vektor einrichten*/
   r=meinricht(m,m);
   d=veinricht(m);

   while(fscanf(fp,"%lG %lG",&x,&y)!=EOF)
   {  /* Bilden einer Zeile der Matrix */
      arbz[0]=1;
      for(j=1;j<=g;j++)
	arbz[j]=arbz[j-1]*x;
      arbz[m]=y;

      /*Transformation*/
       for(p=0;p< (i<m ? i : m) ;p++)
       {
	   if(arbz[p]!=0)
	   {  if(fabs(R[p][p]) < DELTA*fabs(arbz[p]))
	      { co=0; si=1; }
	      else
	      { h=sqrt(R[p][p]*R[p][p]+arbz[p]*arbz[p]);
		co=R[p][p]/h;
		si=-arbz[p]/h;
	      }

	      /*in Matrix*/
	      for(j=p;j<m;j++)
	      { h = R[p][j]*co - arbz[j]*si;
		arbz[j] = R[p][j]*si + arbz[j]*co;
		R[p][j] = h;
	      }
	      /* in Vektor */
	      h = D[p]*co - arbz[m]*si;
	      arbz[m] = D[p]*si + arbz[m]*co;
	      D[p] = h;
	   }
       }
       if(i<m)	 /*Zeile in Matrix kopieren*/
       {  for(j=0;j<m;j++)
	     R[i][j]=arbz[j];
	  D[i]=arbz[m];
       }
       i++;
   }

  fclose(fp);

  u=reinsetz(r,d);
  fprintf(stderr,"Ergebnis:\n");vekaus(u);
}
