/****************************************************
 * DELTA.C  vergleicht zwei Funktionsdateien	    *
 * und rechnet die Absoluten Fehler aus 	    *
 *--------------------------------------------------*
 * Aufruf: delta [-m] fdat1 fdat2		    *
 * -m : Min- und Maximale Abweichung wird berechnet *
 ****************************************************/
#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<math.h>

main(int argc,char *argv[])
{ FILE *fp1,*fp2;
  double x1,y1,x2,y2,delta,max,min;
  int mb;

  /*Kommandozeilenparameter auswerten */
  mb=0;
  if(argc >1 && strcmp(argv[1],"-m")==0) mb=1;
  if(argc-mb<3) {fprintf(stderr,"Aufruf: delta [-m] fdat1 fdat2  \n");exit(1);}

  fp1=fopen(argv[mb+1],"r");
  fp2=fopen(argv[mb+2],"r");
  if(fp1==NULL || fp2==NULL) {fprintf(stderr,"Fehler beim Datei ffnen !\n");exit(1);}

  max=0;min=1000000;
  while(fscanf(fp1,"%G %G",&x1,&y1)!=EOF && fscanf(fp2,"%G %G",&x2,&y2)!=EOF && x1==x2)
  { delta=fabs(y1-y2);
    if(delta<min) min=delta;
    if(delta>max ) max=delta;
    printf("%5.3g  %20.15g\n",x1,delta);
  }
  if(mb)
  { fprintf(stderr,"Minimale Abweichung: %g\n",min);
    fprintf(stderr,"Maximale Abweichung: %g\n",max);
  }
  fclose(fp1);fclose(fp2);
}
