/************************************************************
 *		   GIVENS.C				    *
 *----------------------------------------------------------*
 * Qrtogonaltransformation nach Givens fr groe Systeme    *
 * lst C*x-w=r nach Methode der kleinsten Quadrate	    *
 ************************************************************/
#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include"matrix.h"
#include"rscanf.h"
#define DELTA 1E-15 /*kleinste Zahl mit 1+DELTA!=1*/
#define MAXL 20     /*Lnge der Arbeitszeile*/
#define R r->inh
#define D d->inh
double arbz[MAXL];  /*Arbeitszeile */

main(int argc,char *argv[])
{  int p,q,i,j,n,m,rc;
   FILE *fp1,*fp2;
   MATRIX r;
   VEKTOR u,d;
   double h,si,co;

  /*Auswertung Kommandozeilenparameter*/
  if(argc<2)
  {
    fp1=fp2=stdin;
    fprintf(stderr,"Lsung des Fehlergleichungssystems C*x-w=r ,da Norm r minimal \n");
    fprintf(stderr,"=============================================================\n\n");
    fprintf(stderr," Aufruf: givens Cdat wdat \n");
    fprintf(stderr," Cmat Matritzendatei wdat Vektordatei \n");
    exit(1);
  }
  else
  {
     fp1=fopen(argv[1],"r");
     fp2=fopen(argv[2],"r");
     if(fp1==NULL || fp2==NULL)
     { fprintf(stderr,"Fehler beim Datei ffnen\n");
       exit(1);
     }
  }

   i=0;m=MAXL;
   while((rc=frscanf(fp1,"%G",&h))!=EOF)
   {  j=0;
      while(rc!=EOLN && rc!=EOF)
      {  if(j<m) arbz[j++]=h;
	 else { fprintf(stderr,"Matrix unregelmig!\n");exit(1);}
	 rc=frscanf(fp1,"%G",&h);
      }
      if(fscanf(fp2,"%G",&h)==EOF) {fprintf(stderr,"Vektor zu kurz!\n");exit(1);}
      arbz[j]=h;

      if(i == 0 )
      { m=j;
	/*Matrix und Vektor einrichten*/
	r=meinricht(m,m);
	d=veinricht(m);
      }

      /*Transformation*/
       for(p=0;p< (i<m ? i : m) ;p++)
       {
	   if(arbz[p]!=0)
	   {  if(fabs(R[p][p]) < DELTA*fabs(arbz[p]))
	      { co=0; si=1; }
	      else
	      { h=sqrt(R[p][p]*R[p][p]+arbz[p]*arbz[p]);
		co=R[p][p]/h;
		si=-arbz[p]/h;
	      }

	      /*in Matrix*/
	      for(j=p;j<m;j++)
	      { h = R[p][j]*co - arbz[j]*si;
		arbz[j] = R[p][j]*si + arbz[j]*co;
		R[p][j] = h;
	      }
	      /* in Vektor */
	      h = D[p]*co - arbz[m]*si;
	      arbz[m] = D[p]*si + arbz[m]*co;
	      D[p] = h;
	   }
       }
       if(i<m)	 /*Zeile in Matrix kopieren*/
       {  for(j=0;j<m;j++)
	     R[i][j]=arbz[j];
	  D[i]=arbz[m];
       }
       i++;
   }

  fclose(fp1);fclose(fp1);

  u=reinsetz(r,d);
  fprintf(stderr,"Ergebnis:\n");vekaus(u);
}
