/*****************************************
 * Polynomauswertung mit Hornerschema	 *
 *****************************************/
#include<stdio.h>
#include<stdlib.h>
#define MAXGR 10
/*Globale Deklarationen */
double a[MAXGR];/*Koeffizenten*/
int n;		/*Polynomgrad*/

double horner(double x,int n,double a[]);

int main(int argc,char *argv[])
{ FILE *fp;
  double x,e;

  /*Auswertung Kommandozeilenparameter*/
  if(argc<2)
  { fprintf(stderr,"Koeffizienten ? (Ctrl-Z Ende)\n");
    fp=stdin;
  }
  else fp=fopen(argv[1],"r");
  if(fp==NULL)
  { fprintf(stderr,"Fehler beim ffnen der Datei %s\n",argv[1]);exit(1);}

  /* Koeffizienten einlesen */
  n=0;
  while(n<MAXGR && fscanf(fp,"%lG",&a[n])!=EOF) n++;
  n--;

  /*Auswertungen*/
  fprintf(stderr,"Auswertungen:\n");
  fprintf(stderr,"X                         P(X) \n");
  fprintf(stderr,"===============================\n");
  while(scanf("%lG",&x)!=EOF)
  { e=horner(x,n,a);
    printf("%g\t%30.20g\n",x,e);
  }
  if(argc>1) fclose(fp);
}

/*******************************************
 * Polynom mit Koeffizenten a[i]	   *
 * an Stelle x mit Horner auswerten	   *
 *******************************************/
double horner(double x,int n,double a[])
{ int i;
  double e;

  e=a[n];
  for(i=n-1;i>=0;i--)
  {
     e=e*x+a[i];
  }
  return(e);
}
