/***************************************************
 *  Lagrange - Interpolation                       *
 ***************************************************/
#include <stdio.h>
#define MAXST 20

double x[MAXST]; /*Stuetzstellen */
double y[MAXST]; /*Sttzwerte*/
double l[MAXST]; /*Stuetzkoeffizienten*/

main(int argc,char *argv[])
{  int i,j,n;
   double X,erg,mu,h,k;
   FILE *fp;

   /*Kommandozeilenparameter auswerten */
   if(argc<2)
     fp=stdin;
   else fp=fopen(argv[1],"r");
   if(fp==NULL)
   { fprintf(stderr,"Fehler beim Datei ffnen\n");
     exit(1);
   }

   /*Sttzwerte einlesen */
   i=0;
   while(i<MAXST && fscanf(fp,"%G %G",&x[i],&y[i])!=EOF) i++;
   n=i-1;

   /*Sttzkoeffizienten ausrechnen*/
   l[0]=1;
   for(j=1;j<=n;j++)
   { l[j]=0.0;
     for(i=0;i<=j-1;i++)
     {  l[i]=l[i]/(x[i]-x[j]);
        l[j]+=l[i];
     }
     l[j]*= -1;
   }

   /*Ausgabe Der Koeffizienten: */
   fprintf(stderr,"Koeffizienten nach Lagrange:\n");
   for(i=0;i<=n;i++)
     fprintf(stderr," l[%d]=%30.20g\n",i,l[i]);

   /*Stellen interpolieren:*/
   fprintf(stderr,"Auswertungen:\n");
   fprintf(stderr,"X                            P(X) \n");
   fprintf(stderr,"================================= \n");
   while(scanf("%G",&X)!=EOF)
   { erg=h=0.0;
     for(i=0;i<=n;i++)
     { k=X-x[i];
       if(k==0.0) {erg=y[i]; break;}
       mu=l[i]/k;
       erg+=y[i]*mu;
       h+=mu;
     }
     if(k!=0.0) erg=erg/h;
     printf("%g  %30.20g\n",X,erg);
   }

   /*Datei schlieen */
   if(argc<2)
     fclose(fp);
}