/******************************************
 * LGSAUS.C				  *
 *----------------------------------------*
 * Lst LGS Ax=b mit Austauschverfahren   *
 ******************************************/
#include<stdio.h>
#include"matrix.h"

VEKTOR lgsaus(MATRIX a,VEKTOR b);

main(int argc,char *argv[])
{ FILE *fp1,*fp2;
  MATRIX a;
  VEKTOR b,x,p;
  if(argc<3) fp1=fp2=stdin;
  else
  { fp1=fopen(argv[1],"r");
    fp2=fopen(argv[2],"r");
  }
  if(argc<3) printf("Matrix ?\n");
  a=matein(fp1);
  if(argc<3) printf("Vektor ?\n");
  b=vekein(fp2);

  x=lgsaus(a,b);
  if(x==NULL) {fprintf(stderr,"Nichteindeutig lsbar !\n");exit(1);}
  fprintf(stderr,"Ergebnis:\n");
  vekaus(x);
}

#define A ai->inh
#define N a->n
#define B x->inh

VEKTOR lgsaus(MATRIX a,VEKTOR b)
{ double s,h,q,max,piv;
  int i,j,k,*p;
  MATRIX ai;
  VEKTOR x;
  /*Matrix quadratisch ? */
  if(a->n != a->m) return(NULL);
  if(b->n != a->n) return(NULL);

  /*Hilfsfeld p einrichten */
  p=(int *)malloc(N*sizeof(int));
  for(i=0;i<=N;i++)
     p[i]=0;
  /*Inverse und Lsgvek einrichten */
   x=vekeadd(NULL,-1,b);
 #ifdef ZER
     ai=a;
 #else
     ai=matcopy(a);
 #endif

   for(k=0;k<N;k++)
   { /*Pivot suchen Maximum-strategie*/
      max=0.0;p[k]=0;
      for(i=k;i<N;i++)
      { s=0.0;
	for(j=k;j<N;j++)
	  s+=fabs(A[i][j]);
	q=fabs(A[i][k])/s;
	if(q>max) { max=q; p[k]=i; }
      }
      if(max==0.0)
      { /*matrix nicht invertierbar /Lgs nicht eindeutig lsbar */
	vekweg(x);
	#ifndef ZER
	   matweg(ai);
	#endif
	free(p);
	return(NULL);
      }
      /* falls p[k] !=k Zeilentausch*/
      if(p[k]!=k)
      {
	 for(j=0;j<N;j++)
	 { h=A[k][j];A[k][j]=A[p[k]][j];A[p[k]][j]=h; }
	 h=B[k];B[k]=B[p[k]];B[p[k]]=h;
      }
      piv=A[k][k];

      for(j=0;j<N;j++)
      {
	 if(j!=k)
	 {  A[k][j]=-1*A[k][j]/piv;/* Piviotzeile */
	    for(i=0;i<N;i++)	   /* sonstige*/
	    {  if(i!=k)
		  A[i][j]=A[i][j]+A[i][k]*A[k][j];
	    }
	 }
      }
      B[k]=-1*B[k]/piv; /* in Pivotzeile */

      for(i=0;i<N;i++)
      {  /*Inhomogenitt*/
	 if(i!=k)
	    B[i]=B[i]+A[i][k]*B[k];
	 /*Pivotkolonne*/
	 A[i][k]=A[i][k]/piv;
      }
      /*pivot */
      A[k][k]=1/piv;
   }

   matweg(ai);
   return(x);
}
