/***********************************************************
 * Deklarationen zu  RWMAT.LIB	(Matrizenrechnung)	   *
 ***********************************************************/
 /*--------------Typdeklarationen----------*/
 struct t_matrix { int n; /* Anzahl Zeilen */
		   int m; /* Anzahl Spalten */
		   double **inh;
		 };
 struct t_vektor { int n; /*Dimension*/
		   double *inh;
		 };

 typedef struct t_matrix *MATRIX;
 typedef struct t_vektor *VEKTOR;

 /*---------Technisches-----------------*/
 MATRIX meinricht(int n,int m);        /*Richtet nxm-Matrix ein*/
 VEKTOR veinricht(int n);	       /*Richtet n-dim Vektor ein*/
 MATRIX matcopy(MATRIX a1);	       /*Kopiert Matrix*/
 VEKTOR vekcopy(VEKTOR x);	       /*Kopiert Vektor*/
 void vekinmats(int i,MATRIX a,VEKTOR v);/*Kopiert v in i-te Zeiler von a*/
 void	matweg(MATRIX a);	       /*Schmeit Matrix weg */
 void	vekweg(VEKTOR v);	       /*Schmeit Vektor weg */

 /*---------Ein-Ausgabe-----------------*/
 void	mataus(MATRIX a);
 MATRIX matein(FILE *fp);
 void vekaus(VEKTOR x);
 VEKTOR vekein(FILE *fp);

 /*-----------Matrizen------------------*/
 MATRIX mattrans(MATRIX a1);	       /*Matrix Transponieren*/
 MATRIX matadd(MATRIX a1,MATRIX a2);   /*ERG = a1 + a2*/
 MATRIX mateadd(MATRIX a1,double s,MATRIX a2);	/* erg = a1+s+a2*/
 MATRIX matmul(MATRIX a1,MATRIX a2);	/*Matritzenmultiplikation*/
 int	matgleich(MATRIX a1,MATRIX a2); /*1 falls a1 = a2 0sonst */
 MATRIX matskmul(double s,MATRIX a1);	/*erg =s*a1*/
 MATRIX mateins(int n); 		/*Einheitsmatrix*/
 MATRIX matinvaus(MATRIX a);		/*Inverse mit Austauschverfahren*/
 VEKTOR matmulvek(MATRIX a,VEKTOR v);	/*Matrix * Vektor*/

 /*----------Vektoren--------------------*/
 VEKTOR vekadd(VEKTOR v1,VEKTOR v2);	/*Vektoraddition*/
 VEKTOR vekeadd(VEKTOR v1,double s,VEKTOR v2); /*v1=s*v2 falls v1 NULL	s*v2*/
 double skprod(VEKTOR v1,VEKTOR v2);	/*Skalarprodukt*/
 VEKTOR einsvek(int i,int n);		/*i-ter Einheitsvektor der Dim n*/

 /*----------Normen----------------------*/
 double euknorm(VEKTOR v);		/*Eukidische Norm von Vektor*/
 double maxnorm(VEKTOR v);		/*Maximumsnorm von Vektor */
 double matgesnorm(MATRIX a);		/*Gesamtnorm von Matrix*/
 double matzsumnorm(MATRIX a);		/*Zeilensummennorm von Matrix */

 /*--------Spezielles-------------------*/
int cholesky(MATRIX *l,MATRIX a);	/*a=l*lt, l untere dreiecksmatrix*/
VEKTOR leinsetz(MATRIX l,VEKTOR b);	/* Lst Lx=b L unt. Dreiecksmat.*/
VEKTOR reinsetz(MATRIX r,VEKTOR b);	/* Lst Rx=b R obere " */

