/***************************************************
 *  Newton   - Interpolation                       *
 ***************************************************/
#include <stdio.h>
#define MAXST 20

double x[MAXST]; /*Stuetzstellen */
double y[MAXST]; /*Sttzwerte*/
double c[MAXST]; /*Stuetzkoeffizienten*/

main(int argc,char *argv[])
{  int i,k,n;
   double X,erg;
   FILE *fp;

   /*Kommandozeilenparameter auswerten */
   if(argc<2)
     fp=stdin;
   else fp=fopen(argv[1],"r");
   if(fp==NULL)
   { fprintf(stderr,"Fehler beim Datei ffnen\n");
     exit(1);
   }

   /*Sttzwerte einlesen */
   i=0;
   while(i<MAXST && fscanf(fp,"%G %G",&x[i],&y[i])!=EOF) i++;
   n=i-1;

   /*Sttzkoeffizienten ausrechnen*/
   for(i=0;i<=n;i++)
     c[i]=y[i];
   for(i=1;i<=n;i++)
      for(k=n;k>=i;k--)
         c[k]=(c[k]-c[k-1])/(x[k]-x[k-i]);

   /*Ausgabe Der Koeffizienten: */
   fprintf(stderr,"Koeffizienten nach Newton:\n");
   for(i=0;i<=n;i++)
     fprintf(stderr," c[%d]=%30.20g\n",i,c[i]);

   /*Stellen interpolieren:*/
   fprintf(stderr,"Auswertungen:\n");
   fprintf(stderr,"X                         P(X) \n");
   fprintf(stderr,"===============================\n");
   while(scanf("%G",&X)!=EOF)
   {  erg=c[n];
      for(i=n-1;i>=0;i--)
         erg=erg*(X-x[i])+c[i];
      printf("%g  %30.20g\n",X,erg);
   }

   /*Datei schlieen */
   if(argc<2)
     fclose(fp);
}