/************************************************************
 * SCHAU.C Schaubild zu einer Funktionswertedatei zeichnen  *
 *----------------------------------------------------------*
 * Parameter: Funktionsdateien				    *
 * speziell : -s	:stdin				    *
 *	      -pdatname :Wird punktweise gezeichnet	    *
 *	      -xy	:die nchsten zwei Parameter	    *
 *			 sind zwei parameterfunktionen	    *
 *			 fr eine zweidimensionale Kurve    *
 * 1.param = /k:Konfigurationsdatei erstellen		    *
 *	     /o:kein Koordinatenachsen werden gezeichnet    *
 ************************************************************/
#include<stdio.h>
#include<dos.h>
#include<string.h>
#include"graphik.h"

/*Funktionsdeklarationen*/
void plot(FILE *fp);
void fpw(FILE *fp);
void parmplot(FILE *fp1,FILE *fp2);

/*Globale Variablen:*/
int ux,ox,uy,oy,d;
int refehler;	/*fr graphik.c*/

main(int argc,char **argv)
{ FILE *fp,*fp2,*kf;
  int i,ks;
  if(argc<2) {fprintf(stderr,"Zuwenig Parameter!");exit(1);}

  /*Bildschirm Parameter aus Konfigurationsdatei lesen*/
  kf=fopen("schau.cfg","r");
  if(kf==NULL)
  { fprintf(stderr,"Konfigurationsdatei nicht vorhanden!\n");
    ux=uy=-10;ox=oy=10;d=10;
  }
  else
  { fscanf(kf,"%d,%d\n%d,%d\n%d\n",&ux,&uy,&ox,&oy,&d);
    fclose(kf);
  }
   /*Konfigurationsdatei erstellen ? */
  i=1;
  if(strcmp(argv[i],"/k")==0)
  { kf=fopen("schau.cfg","w");
    fprintf(stderr,"ux ?");scanf("%d",&ux);
    fprintf(stderr,"uy ?");scanf("%d",&uy);
    fprintf(stderr,"ox ?");scanf("%d",&ox);
    fprintf(stderr,"oy ?");scanf("%d",&oy);
    fprintf(stderr,"d  ?");scanf("%d",&d );
    fprintf(kf,"%d,%d\n%d,%d\n%d\n",ux,uy,ox,oy,d);
    fclose(kf);
    i++;
  }
  /*Koordinatensystem zeichnen ?*/
  ks=1;
  if(strcmp(argv[i],"/o")==0)
  { ks=0;i++;
  }
  /*Zeichnen:*/
  grein();
  kosys(ux,uy,ox,oy,ks);

  while(argv[i]!=NULL)
  { if(strcmp(argv[i],"-xy")==0)
    { fp=fopen(argv[++i],"r");
      fp2=fopen(argv[++i],"r");
      parmplot(fp,fp2);
      fclose(fp);fclose(fp2);
    }
    else if(argv[i][0]=='-')
    { if(argv[i][1]=='s') plot(stdin);
      else if(argv[i][1]=='p')
      { fp=fopen(argv[i]+2,"r");
	fpw(fp);
	fclose(fp);
      }
    }
    else
    { fp=fopen(argv[i],"r");
      plot(fp);
      fclose(fp);
    }
    i++;
  }
  warte();
  graus();
}

int warte()
{  union REGS reg;
   /*Zeichen lesen */
   reg.h.ah=0;
   int86(0X16,&reg,&reg);
}

void plot(FILE *fp)
{
  int x,y,xalt,yalt;
  double X,Y;	  /*Werte aus Datei*/

  if(fscanf(fp,"%G %G",&X,&Y)==EOF) return;
  xalt=(int)((X-ux)/(double)(ox-ux)*639);
  yalt=(int)((oy-Y)/(double)(oy-uy)*199);
  while(fscanf(fp,"%G %G",&X,&Y)!=EOF)
  {
    x=(int)((X-ux)/(double)(ox-ux)*639);
    y=(int)((oy-Y)/(double)(oy-uy)*199);
    if(abs(y-yalt)>d) {yalt=y;xalt=x;}
    if(y>0 && y<200)
    {  linie(xalt,yalt,x,y,'a');}
    else if(y<=0) y=0;
	 else y=199;

    xalt=x;yalt=y;
  }
  printf("\007");
}

/*Funktionswerte Punktweise aufzeichnen*/
void fpw(FILE *fp)
{
  int x,y;
  double X,Y;	  /*Werte aus Datei*/

  while(fscanf(fp,"%G %G",&X,&Y)!=EOF)
  {
    x=(int)((X-ux)/(double)(ox-ux)*639);
    y=(int)((oy-Y)/(double)(oy-uy)*199);
    psetz(y,x);
  }
  printf("\007");
}

void parmplot(FILE *fp1,FILE *fp2)
{
  int x,y,xalt,yalt;
  double t1,t2,X,Y;	/*Werte aus Datei*/

  if(fscanf(fp1,"%G %G",&t1,&X)==EOF || fscanf(fp2,"%G %G",&t2,&Y)==EOF || t1!=t2) return;
  xalt=(int)((X-ux)/(double)(ox-ux)*639);
  yalt=(int)((oy-Y)/(double)(oy-uy)*199);
  while(fscanf(fp1,"%G %G",&t1,&X)!=EOF && fscanf(fp2,"%G %G",&t2,&Y)!=EOF && t1==t2)
  {
    x=(int)((X-ux)/(double)(ox-ux)*639);
    y=(int)((oy-Y)/(double)(oy-uy)*199);
    if(abs(y-yalt)>d) {yalt=y;xalt=x;}
    if(y>0 && y<200)
    {  linie(xalt,yalt,x,y,'a');}
    else if(y<=0) y=0;
	 else y=199;

    xalt=x;yalt=y;
  }
  printf("\007");
}
