/**********************************************************
 * Lsen von Gleichungssystemen in Dreiecksform:          *
 **********************************************************/
#include<stdio.h>
#include"matrix.h"
/* Schreibvereinfachung */
#define L l->inh
#define B b->inh
#define X x->inh
#define N l->n
/***********************************************************
 *VEKTOR leinsetz(MATRIX l,VEKTOR b)                       *
 *---------------------------------------------------------*
 *Zweck.....:Lst Gleichungssystem (l|b)                   *
 *Ergebnis..:Lsungsvektor                                 *
 *Parameter.:l Untere Dreiecksmatrix (Koeffizentenmatrix)  *
 *           b Inhomogenitt                               *
 ***********************************************************/
VEKTOR leinsetz(MATRIX l,VEKTOR b)
{ int i,j;
  VEKTOR x;
  if(l->n != l->m) {fprintf(stderr,"Matrix nicht quadratisch!\n");return(NULL);}
  if(b->n != l->m)
  { fprintf(stderr,"Dimenision Matrix(m) %d -Vektor %d stimmt nicht!\n",l->m,b->n);
    return(NULL);
  }
  x=veinricht(N);
  for(i=0;i<N;i++)
  {  X[i]=B[i];
     for(j=0;j<i;j++)
        X[i]-=L[i][j]*X[j];
     if(L[i][i]!=0.0) X[i]/=L[i][i];
     else { fprintf(stderr,"Nicht eindeutig lsbar!\n");
            vekweg(x);
            return(NULL);
          }
  }

 return(x);
}

#undef  N
#define R r->inh
#define N r->n
/***********************************************************
 *VEKTOR reinsetz(MATRIX r,VEKTOR b)                       *
 *---------------------------------------------------------*
 *Zweck.....:Lst Gleichungssystem (r|b)                   *
 *Ergebnis..:Lsungsvektor                                 *
 *Parameter.:r Obere Dreiecksmatrix (Koeffizentenmatrix)   *
 *           b Inhomogenitt                               *
 ***********************************************************/
VEKTOR reinsetz(MATRIX r,VEKTOR b)
{ int i,j;
  VEKTOR x;
  if(r->n != r->m) {fprintf(stderr,"Matrix nicht quadratisch!\n");return(NULL);}
  if(b->n != r->n) {fprintf(stderr,"Dimenision Matrix-Vektor stimmt nicht!\n");return(NULL); }
  x=veinricht(N);
  for(i=N-1;i>=0;i--)
  {  X[i]=B[i];
     for(j=i+1;j<N;j++)
        X[i]-=R[i][j]*X[j];

     if(R[i][i]!=0.0) X[i]/=R[i][i];
     else { fprintf(stderr,"Nicht eindeutig lsbar!\n");
            vekweg(x);
            return(NULL);
          }
  }
  return(x);
}
