/************************************************
 *  Austauschverfahren				*
 ************************************************/
/* #define ZER	 Spart Platz*/
#include<stdio.h>
#include<math.h>
#include"matrix.h"
#include<stdlib.h>

#define A ai->inh
#define N a->n

/**********************************************************
 * Berechnet Inverse einer Matrix mit Austauschverfahren  *
 **********************************************************/
MATRIX matinvaus(MATRIX a)
{ double s,h,q,max,piv;
  int i,j,k,*p;
  MATRIX ai;
  /*Matrix quadratisch ? */
  if(a->n != a->m) return(NULL);

  /*Hilfsfeld p einrichten */
  p=(int *)malloc(N*sizeof(int));
  for(i=0;i<=N;i++)
     p[i]=0;
  /*Inverse einrichten */
 #ifdef ZER
     ai=a;
 #else
     ai=matcopy(a);
 #endif
   for(k=0;k<N;k++)
   { /*Pivot suchen Maximum-strategie*/
      max=0.0;p[k]=0;
      for(i=k;i<N;i++)
      { s=0.0;
	for(j=k;j<N;j++)
	  s+=fabs(A[i][j]);
	q=fabs(A[i][k])/s;
	if(q>max) { max=q; p[k]=i; }
      }
      if(max==0.0)
      { /*matrix nicht invertierbar */
	#ifndef ZER
	   matweg(ai);
	#endif
	free(p);
	return(NULL);
      }
      /* falls p[k] !=k Zeilentausch*/
      if(p[k]!=k)
      {
	 for(j=0;j<N;j++)
	 { h=A[k][j];A[k][j]=A[p[k]][j];A[p[k]][j]=h; }
      }
      piv=A[k][k];

      for(j=0;j<N;j++)
      {
	 if(j!=k)
	 {  A[k][j]=-1*A[k][j]/piv;/* Piviotzeile */
	    for(i=0;i<N;i++)	   /* sonstige*/
	    {  if(i!=k)
		  A[i][j]=A[i][j]+A[i][k]*A[k][j];
	    }
	 }
      }
      /*Pivotkolonne*/
      for(i=0;i<N;i++)
	 A[i][k]=A[i][k]/piv;
      /*pivot */
      A[k][k]=1/piv;
   }
   /* Spalten richtig hintauschen */
   for(k=N-1;k>=0;k--)
     if(p[k]!=k)
       for(i=0;i<N;i++)
       { h=A[i][k];A[i][k]=A[i][p[k]];A[i][p[k]]=h; }

   return(ai);
}


