/***********************************************************
 *  Modul matrix.c					   *
 *---------------------------------------------------------*
 * Unterprogramme zur Matrizenrechnung			   *
 ***********************************************************/
#include<stdio.h>
#include "matrix.h" /*Deklarationen*/


/*Schreibvereinfachung*/
#define A1 a1->inh
#define N1 a1->n
#define M1 a1->m
#define A2 a2->inh
#define N2 a2->n
#define M2 a2->m
#define E  e->inh

MATRIX mattrans(MATRIX a1)
{ int i,j;
  MATRIX e;
  e=meinricht(M1,N1);
  for(i=0;i<N1;i++)
     for(j=0;j<M1;j++)
	E[j][i]=A1[i][j];
  return(e);
}


MATRIX matadd(MATRIX a1,MATRIX a2)
{ int i,j;
  MATRIX e;
  if(N1!=N2 || M1!=M2 ) return(NULL); /*Typen stimmen nicht!*/
  e=meinricht(N1,M1);
  for(i=0;i<N1;i++)
     for(j=0;j<M1;j++)
	E[i][j]=A1[i][j]+A2[i][j];
  return(e);
}

MATRIX mateadd(MATRIX a1,double s,MATRIX a2)
{ int i,j;
  MATRIX e;
  if(N1!=N2 || M1!=M2 ) return(NULL); /*Typen stimmen nicht!*/
  e=meinricht(N1,M1);
  for(i=0;i<N1;i++)
     for(j=0;j<M1;j++)
	E[i][j]=A1[i][j]+s*A2[i][j];
  return(e);
}

MATRIX matmul(MATRIX a1,MATRIX a2)
{ int i,j,k;
  MATRIX e;
  if(M1!=N2) return(NULL); /*Typen stimmen nicht!*/
  e=meinricht(N1,M2);
  for(i=0;i<N1;i++)
     for(j=0;j<M2;j++)
     {	E[i][j]=0.0;
	for(k=0;k<M1;k++)
	   E[i][j]+=A1[i][k]*A2[k][j];
     }
  return(e);
}

int    matgleich(MATRIX a1,MATRIX a2)
{ int i,j;
  if(N1!=N2 || M1!=M2 ) return(0); /*Typen stimmen schon nicht!*/
  for(i=0;i<N1;i++)
     for(j=0;j<M1;j++)
	if(A1[i][j]!=A2[i][j]) return(0);
  return(1);
}

MATRIX matskmul(double s,MATRIX a1)
{ int i,j;
  MATRIX e;
  e=meinricht(N1,M1);
  for(i=0;i<N1;i++)
     for(j=0;j<M1;j++)
	E[i][j]=A1[i][j]*s;
  return(e);
}

MATRIX mateins(int n)
{ int i,j;
  MATRIX e;
  e=meinricht(n,n);
  for(i=0;i<n;i++)
     for(j=0;j<n;j++)
	if(i==j) E[i][j]=1.0;
	else	 E[i][j]=0.0;
  return(e);
}

/*Schreibvereinfachung aufheben*/
#undef A1
#undef N1
#undef M1
#undef A2
#undef N2
#undef M2
#undef E
/*Neue Schreibvereinfachung*/
#define A a->inh
#define V v->inh
#define N a->n
#define M a->m
#define D v->n
#define EV ev->inh

VEKTOR matmulvek(MATRIX a,VEKTOR v)
{ int i,j;
  VEKTOR ev;
  if(M!=D) return(NULL); /*Dimension stimmt nicht */
  ev=veinricht(N);
  for(i=0;i<N;i++)
  { EV[i]=0;
    for(j=0;j<M;j++)
       EV[i]=EV[i]+A[i][j]*V[j];
  }
  return(ev);
}

#undef A
#undef V
#undef N
#undef M
#undef D
#undef EV
