/***********************************************************************
 * Technische Sachen fr Matritzen und Vektoren ohne tiefere Bedeutung *
 ***********************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include "matrix.h"

/* Vektor einricheten */
VEKTOR veinricht(int n)
{ int i;
  VEKTOR x;
  x=(VEKTOR)malloc(sizeof(struct t_vektor));
  if(x==NULL) {fprintf(stderr,"Kein Speicher mehr!\n");exit(1);}
  x->n=n;
  x->inh=(double *)malloc(n*sizeof(double));
  if(x->inh==NULL) {fprintf(stderr,"Kein Speicher mehr!\n");exit(1);}
  for(i=0;i<n;i++)
    x->inh[i]=0;
  return(x);
}

/*Vektor entfernen*/
 void	vekweg(VEKTOR v)
 { free(v->inh);
   free(v);
 }

/*Vektor kopieren*/
VEKTOR vekcopy(VEKTOR x)
{ int i;
  VEKTOR e;
  e=veinricht(x->n);
  for(i=0;i<x->n;i++)
    e->inh[i]= x->inh[i];
  return(e);
}

/* Matrix einrichten */
 MATRIX meinricht(int n,int m)
 {
   MATRIX h;
   int i,j;
   h=(MATRIX)malloc(sizeof(struct t_matrix));
   if(h==NULL) {fprintf(stderr,"kein Speicher mehr !\n");exit(1);}
   h->n=n;h->m=m;
   h->inh=(double **)malloc(n*sizeof(double *));
   if(h->inh==NULL) {fprintf(stderr,"kein Speicher mehr !\n");exit(1);}
   for(i=0;i<n;i++)
   {
      h->inh[i]=(double *)malloc(m*sizeof(double));
      if(h->inh[i]==NULL) {fprintf(stderr,"kein Speicher mehr !\n");exit(1);}
      for(j=0;j<m;j++)
	 h->inh[i][j]=0.0;

   }
   return(h);
 }

/*Matrix entfernen */
 void matweg(MATRIX a)
 { int i;
   for(i=0;i<a->n;i++)
      free(a->inh[i]);
   free(a);
 }

/*Schreibvereinfachung*/
#define A1 a1->inh
#define N1 a1->n
#define M1 a1->m
#define E  e->inh

/*Matix kopieren*/
MATRIX matcopy(MATRIX a1)
{ int i,j;
  MATRIX e;
  e=meinricht(N1,M1);
  for(i=0;i<N1;i++)
     for(j=0;j<M1;j++)
	E[i][j]=A1[i][j];
  return(e);
}

/* Setzt Vektor v in i-te Spalte der Matrix a */
void vekinmats(int i,MATRIX a,VEKTOR v)
{ int j;
  if(a->n != v->n)
  { fprintf(stderr,"vekinmats:Dimension Vektor stimmt nicht mit #Matrix Zeilen berein !\n");exit(1);}
  if(i >= a->m || i<0)
  { fprintf(stderr,"vekinmats:Spaltennr ungltig !\n");exit(1);}

  for(j=0;j<a->n;j++)
     a->inh[j][i]=v->inh[j];
}

