/*******************************************************
 * Matrix - und Vektornormen			       *
 *******************************************************/
#include<stdio.h>
#include<stdlib.h>
#include"matrix.h"
#include<math.h>

/*----------------------------------------------*
 * Vektornormen 				*
 *----------------------------------------------*/
/*Euklidische Norm*/
double euknorm(VEKTOR v)
{ return(sqrt(skprod(v,v)));
}

/*Maximumsnorm*/
#define V v->inh
#define N v->n

double maxnorm(VEKTOR v)
{ double max;
  int i;
  max=0.0;
  for(i=0;i<N;i++)
    if(max < fabs(V[i])) max=fabs(V[i]);

  return(max);
}

#undef N
#define A a->inh
#define N a->n
/*----------------------------------------------*
 * Matrixnormen 				*
 *----------------------------------------------*/
/* Gesamtnorm */
double matgesnorm(MATRIX a)
{ int i,j;
  double m,h;
  if(a->n != a->m)
  { fprintf(stderr,"Gesamtnorm nur fuer quadratsche Matritzen !\n");exit(1);}

  m=0.0;
  for(i=0;i<N;i++)
     for(j=0;j<N;j++)
	if((h=fabs(A[i][j]))>m) m=h;
  return(N*m);
}


/* Zeilensummennorm*/
double matzsumnorm(MATRIX a)
{ int i,j;
  double m,z;
  if(a->n != a->m)
  { fprintf(stderr,"Zeilensummennorm nur fuer quadratsche Matritzen !\n");exit(1);}

  m=0.0;
  for(i=0;i<N;i++)
  {  z=0.0;
     for(j=0;j<N;j++)
	z+=fabs(A[i][j]);
     if(z>m) m=z;
  }
  return(m);
}
