/*******************************************************
 * frscanf()                                           *
 * wie fscanf nur liefert bei, einlesen von '\n' EOLN  *
 * format wird nur "%d %G %s %c"   untersttzt         *
 *******************************************************/
#include<stdio.h>
#include<stdarg.h>
#include<stdlib.h>
#include<ctype.h>
#ifndef EOF
#define EOF (-1)
#endif
#define EOLN -2
#define MAXSP 81    /*Speicherlnge*/

int frscanf(FILE *fp,char *format, ...);

int frscanf(FILE *fp,char *format, ...)
{ va_list argpoint;

  int c;                /*Aktueller Buchstabe Eingabe*/
  int f;                /*index akt Buchst. formatstr. */
  int i;                /*Index Speicher */
  char speich[MAXSP];
  char *str;
  /*Initialisierung*/
  i=f=0;
  va_start(argpoint,format);

  /*Formatstring analysieren*/
  while(format[f]!='\0')
  { if(format[f]!='%') {f++;continue;} /* '%' suchen */
    f++;
    /* weie Leerzeichen berlesen und ggf verarbeiten */
    while((c=getc(fp))!=EOF && c!='\n' && isspace(c));
    if(c==EOF) return(EOF);
    if(c=='\n') return(EOLN);
    switch(format[f])
    { case  'd':/* int lesen */
                if(c=='-' || c=='+') { speich[i++]=c;c=getc(fp);}
                while(isdigit(c))
                { speich[i++]=c;
                  c=getc(fp);
                }
                speich[i]=0;
                ungetc(c,fp);
                *va_arg(argpoint,int *)=atoi(speich);
                break;
      case  'G':/*double lesen*/
                if(c=='-' || c=='+') { speich[i++]=c;c=getc(fp);}
                while(isdigit(c))
                { speich[i++]=c;
                  c=getc(fp);
                }
                if(c=='.')
                {  speich[i++]=c;
                   c=getc(fp);
                   while(isdigit(c))
                   { speich[i++]=c;
                     c=getc(fp);
                   }
                }
                if(c=='e' || c=='E')
                { speich[i++]=c;c=getc(fp);
                  if(c=='-' || c=='+') { speich[i++]=c;c=getc(fp);}
                  while(isdigit(c))
                  { speich[i++]=c;
                    c=getc(fp);
                  }
                }
                speich[i]=0;
                ungetc(c,fp);
                *va_arg(argpoint,double *)=atof(speich);
                break;
      case  'c':/*Buchstabe lesen*/
                *va_arg(argpoint,char *)=c;
                break;
      case  's':/*String einlesen*/
                str=va_arg(argpoint,char *);
                while(isgraph(c))
                { str[i++]=c;
                  c=getc(fp);
                }
                str[i]='\0';
                ungetc(c,fp);
                break;
      case '\0':continue;
    }
    f++;
  }
  return(1);
}

