/***********************************************************
 *  Modul vektor.c					   *
 *---------------------------------------------------------*
 * Unterprogramme zur Vektorrechnung			   *
 ***********************************************************/
#include<stdio.h>
#include<stdlib.h>
#include "matrix.h" /*Deklarationen*/

/*Schreibvereinfachung*/
#define V1 v1->inh
#define V2 v2->inh
#define N1 v1->n
#define N2 v2->n
#define E  e->inh

VEKTOR vekadd(VEKTOR v1,VEKTOR v2)
{ VEKTOR e;
  int i;
  if(N1!=N2) return(NULL); /*Verweigerung*/
  e=veinricht(N1);
  for(i=0;i<N1;i++)
     E[i]=V1[i]+V2[i];
  return(e);
}

double skprod(VEKTOR v1,VEKTOR v2)
{ double erg;
  int i;
  if(N1!=N2) {fprintf(stderr,"Dimension stimmt nicht");return(0.0);  }
  erg=0;
  for(i=0;i<N1;i++)
     erg+=V1[i]*V2[i];
  return(erg);
}

/**************************************************
 * rechnet v1+s*v2 falls v1 definiert		  *
 *	      s*v2 falls v1 !=NULL		  *
 **************************************************/
VEKTOR vekeadd(VEKTOR v1,double s,VEKTOR v2)
{ int i;
  VEKTOR e;
  if(v1!=NULL && v1->n != v2->n)
  { fprintf(stderr,"vekeadd:Dimensionen stimmen nicht berein!\n");exit(1);}

  e=veinricht(v2->n);
  for(i=0;i<v2->n;i++)
  { if(v1) E[i]=V1[i]+s*V2[i];
    else E[i]=s*V2[i];
  }
  return(e);
}
#undef V1
#undef V2
#undef N1
#undef N2
#undef E

/* i- ter Einheitsvektor der Dimension m */
VEKTOR einsvek(int i,int n)
{ VEKTOR r;
  if(i>=n) {fprintf(stderr,"einsvek:i zu gro!\n");exit(1);}
  r=veinricht(n);
  r->inh[i]=1.0;
  return(r);
}
