#include <iostream>
#include <stdio.h>
#include "grupstich_out.h"
#include "CovBerechnung.h"
extern int verbose;

bool CovBerechnung::init(const char *fieldlist)
{
   covfl.interpretiereliste(fieldlist);
   if(covfl.len()<2)
   {
       std::clog << "Die Kovarianzliste muss mindestens 2 Felder haben!"
		 << std::endl;
       return false;
   }
   covmat.init(covfl.len());
   return true;
}

void  CovBerechnung::calcconnections(Stat *sammel,const Feldliste& allefl)
{
    for(int i=1;i<covfl.len();i++)
    {
	for(int j=0;j<i;j++)
	{
	    int si,sj; // index fuer Sammelung
	    si = allefl.index(covfl[i]);
	    sj = allefl.index(covfl[j]);
#ifdef DEBUG
	    std::clog << '(' << i << ',' << j << ") "
		      << '[' << (covfl[i]+1) << ',' << (covfl[j]+1) << ']'
		      << " si=" << si << "(" << allefl[si] << ")" 
		      << " sj=" << sj << "(" << allefl[sj] << ")";
#endif	  
	    covmat(i,j).connect(sammel+si,sammel+sj);
	}
#ifdef DEBUG
	std::clog << std::endl;
#endif
    }
}

void CovBerechnung::Add(double *x)
{
    for(int i=1;i<covfl.len();i++)
    {
	for(int j=0;j<i;j++)
	{
	    if(verbose>1)
	    {
		std::clog << '(' << i << ',' << j << ") "
			  << '[' << (covfl[i]+1) << ',' << (covfl[j]+1) << ']'
		          << " add("<< x[covfl[i]] << ',' << x[covfl[j]] << ')';
	    }
	    covmat(i,j).add(x[covfl[i]],x[covfl[j]]);
	}
	if(verbose > 1)
	{
	    std::clog << std::endl;
	}
    }
}

void CovBerechnung::Print(Aet *ausformat,char trenn)
{
    if(covfl.len() == 2) // nur bei 2 Covarianzfeldern
    {
	for(Aet *ap=ausformat;*ap!=AE_ENDE;ap++)
	{
	    switch(*ap)
	    {
		case AE_COV:  printf("%g%c",covmat(1,0).kovarianz(),trenn); break;
		case AE_CORR: printf("%g%c",covmat(1,0).r(),trenn); break;
		default:
		    break;	      
	    }
	}
    }
}

void CovBerechnung::PrintMatrix()
{
	  if(verbose > 0)
	  {
	      std::cout << "##X*Y\t";
	      for(int j=0;j<covmat.n()-1;j++)
	      {
		  std::cout << (covfl[j]+1) << '\t';
	      }
	      std::cout << std::endl;
	      for(int i=1;i<covmat.n();i++)
	      {
		  std::cout << '#' << (covfl[i]+1) << ":\t";
		  for(int j=0;j<i;j++)
		  {
		      std::cout <<  covmat(i,j).sumXY() << "\t";
		  }
		  std::cout << std::endl;
	      }
	  }
	  std::cout << "##COV(X,Y)\t";
	  for(int j=0;j<covmat.n()-1;j++)
	  {
	      std::cout << (covfl[j]+1) << '\t';
	  }
	  std::cout << std::endl;
	  for(int i=1;i<covmat.n();i++)
	  {
	      std::cout << '#' << (covfl[i]+1) << ":\t";
	      for(int j=0;j<i;j++)
	      {
		  std::cout <<  covmat(i,j).kovarianz() << "\t";
	      }
	      std::cout << std::endl;
	  }
	  std::cout << "##R(X,Y)\t";
	  for(int j=0;j<covmat.n()-1;j++)
	  {
	      std::cout << (covfl[j]+1) << '\t';
	  }
	  std::cout << std::endl;
	  for(int i=1;i<covmat.n();i++)
	  {
	      std::cout << '#' << (covfl[i]+1) << ":\t";
	      for(int j=0;j<i;j++)
	      {
		  std::cout <<  covmat(i,j).r() << "\t";
	      }
	      std::cout << std::endl;
	  }
}

void CovBerechnung::Reset()
{
    for(int i=0;i<covmat.n();i++)
    {
	for(int j=0;j<i;j++)
	{
	    covmat(i,j).init();
	}
    }
}
