/*********************************************************************** 
 * Klasse...: Stat                                                     * 
 * Zweck....: Sammelt Stichprobe                                       * 
 *---------------------------------------------------------------------*
 * Copyright: 1994,1995 Rudolf Weber,                                  *
 *            IMMD IV University Erlangen-Nrnberg                  *
 * Distribution: GNU-Copy-left                                         *
 ***********************************************************************/ 
#ifndef STAT_H
#define STAT_H
#include<math.h> 
 
class Stat 
{ 
  int N; 
  double Min,Max; 
  double Sum,Sum2; 
  double s2; 
 
public: 
  Stat() { init(); } 
  void init() 
  { 
    N = 0; 
    Max = -HUGE_VAL; 
    Min = HUGE_VAL; 
    Sum = 0.0; 
    Sum2 = 0.0; 
  } 
   
  void add(double x) 
  { 
    N++; 
    Sum += x; 
    Sum2 += x*x; 
    if(x < Min) Min = x; 
    if(x > Max) Max = x; 
  } 
 
  int n()           { return N; } 
  double min()      { return Min; } 
  double max()      { return Max; } 
  double sum()      { return Sum; } 
  double sum2()     { return Sum2; } 
  double mittel()   { return Sum/(double)N; } 
  double varianz()  { return N>1 ? (Sum2 - Sum*Sum/(double)N)/(double)(N-1) :0.0; } 
  double streuung() { return sqrt(varianz()); } 
}; 
#endif
