#ifndef UDM_H
#define UDM_H

/* Speicherstruktur untere Dreiecksmatrix
   Enthaellt nur felder (i=1..n-1; j=0..i-1)
 */
template<class T> class UDM
{
public:
    UDM():n_(0),con(0) {}
    UDM(int n):n_(n) 
    {
	init(n);
    }
    void init(int n)
    {
	n_=n;
	alloced_ = pos(n-1,n-1)+1;
	if(alloced_==0) { alloced_=1; }
	con = new T[alloced_];
    }

    ~UDM()
    {
	delete [] con;
    }
    T& operator()(int i,int j) { return con[pos(i,j)]; }
    const T& operator() (int i,int j) const { return con[pos(i,j)]; }
    int n() { return n_; }
private:
    int n_;
    int alloced_;
    T* con;
    int pos(int i,int j) const
    {
	return (i-1)*i/2+j;
    }
};
#endif
