#ifndef MEDIAN_H
#define MEDIAN_H
#include<ostream>
#include<stdio.h>
class Median
{
 public:
   class ZuWenigWerte : public std::exception
  {
  protected:
      char errmsg[128];
      int anzwerte_;
  public:
      ZuWenigWerte(int aw):anzwerte_(aw)
      {
	  snprintf(errmsg,128,
		   "Zu wenig Werte: %d (min. 1)",
		   aw);
      }
      virtual const char *what() const throw() { return errmsg; }
  };
 public:
    Median(int cap);
    void add(double w);
    void schreibestichprobe(std::ostream &ostr);
    void sortstichprobe();
    double median() throw (ZuWenigWerte);
 private:
    double *stichprobe_;
    int cap_;
    int n_;
    void resize();
    static int vergleich(const void *t1,const void *t2);
};
#endif
