/**********************************************************************
 * Tcl-Modul fr statistik                                            *
 **********************************************************************/
#include<string.h>
#include"Stat.h"
extern "C" 
{
#include"tcl.h"
}

   extern "C" int StatCmd(ClientData cldat,Tcl_Interp *interp,
			  int argc,char **argv);

   extern "C" void DeleteStat(ClientData cldat);

   extern "C" int StatObjCmd(ClientData cldat,Tcl_Interp *interp,
			  int argc,char **argv);

   extern "C" int Stat_Init(Tcl_Interp *interp);

   int Stat_Init(Tcl_Interp *interp)
   {
     Tcl_CreateCommand(interp,"statistik",StatCmd,
		       (ClientData)0,(Tcl_CmdDeleteProc *)NULL);

     if (Tcl_PkgProvide (interp, "Stat","1.0") == TCL_ERROR) {
       return TCL_ERROR;
     }

     return TCL_OK;
   }

   int StatCmd(ClientData cldat,Tcl_Interp *interp,
			  int argc,char **argv)
   {
     static int id = 0;
     static char name[10];
     if(argc != 1)
     {
       interp->result = "wrong # args";
       return TCL_ERROR;
     }
     Stat *statptr = new Stat();
     snprintf(name,10,"stat%d",id);
     Tcl_SetResult(interp,name,TCL_STATIC);
     id++;
     Tcl_CreateCommand(interp,interp->result,StatObjCmd,
		       (ClientData)statptr,DeleteStat);
     return TCL_OK;
   }

   int StatObjCmd(ClientData cldat,Tcl_Interp *interp,
			  int argc,char **argv)
   {
     char erg[128];
     Stat *sp = (Stat *)cldat;
     if(argc < 2)
     {
       Tcl_SetResult(interp,"Wrong # args",TCL_STATIC);
       return TCL_ERROR;
     }
     if(strcmp(argv[1],"add")==0 && argc == 3)
     {
       double x;
       if(Tcl_GetDouble(interp,argv[2],&x)!=TCL_OK) return TCL_ERROR;
       sp->add(x);
       return TCL_OK;
     }
     else if(strcmp(argv[1],"mittel")==0 && argc == 2)
     {
       snprintf(erg,100,"%g",sp->mittel());
       Tcl_SetResult(interp,erg,TCL_VOLATILE);
       return TCL_OK;
     }
     else if(strcmp(argv[1],"n")==0 && argc == 2)
     {
       snprintf(erg,100,"%d",sp->n());
       Tcl_SetResult(interp,erg,TCL_VOLATILE);
       return TCL_OK;
     }
     else if(strcmp(argv[1],"sum")==0 && argc == 2)
     {
       snprintf(erg,100,"%g",sp->sum());
       Tcl_SetResult(interp,erg,TCL_VOLATILE);
       return TCL_OK;
     }
     else if(strcmp(argv[1],"sum2")==0 && argc == 2)
     {
       snprintf(erg,100,"%g",sp->sum2());
       Tcl_SetResult(interp,erg,TCL_VOLATILE);
       return TCL_OK;
     }
     else if(strcmp(argv[1],"min")==0 && argc == 2)
     {
       snprintf(erg,100,"%g",sp->min());
       Tcl_SetResult(interp,erg,TCL_VOLATILE);
       return TCL_OK;
     }
     else if(strcmp(argv[1],"max")==0 && argc == 2)
     {
       snprintf(erg,100,"%g",sp->max());
       Tcl_SetResult(interp,erg,TCL_VOLATILE);
       return TCL_OK;
     }
     else if(strcmp(argv[1],"varianz")==0 && argc == 2)
     {
       snprintf(erg,100,"%g",sp->varianz());
       Tcl_SetResult(interp,erg,TCL_VOLATILE);
       return TCL_OK;
     }
     else if(strcmp(argv[1],"streuung")==0 && argc == 2)
     {
       snprintf(erg,100,"%g",sp->streuung());
       Tcl_SetResult(interp,erg,TCL_VOLATILE);
       return TCL_OK;
     }
     else if(strcmp(argv[1],"all")==0)
     {
       snprintf(erg,100,"n = %d\n",sp->n());Tcl_AppendElement(interp,erg);
       snprintf(erg,100,"min = %g\n",sp->min());Tcl_AppendElement(interp,erg);
       snprintf(erg,100,"max = %g\n",sp->max());Tcl_AppendElement(interp,erg);
       snprintf(erg,100,"Mittelwert= %g\n\n",sp->mittel());Tcl_AppendElement(interp,erg);
       snprintf(erg,100,"Summe\t=%g\n",sp->sum());Tcl_AppendElement(interp,erg);
       snprintf(erg,100,"Quadratsumme= %g\n",sp->sum2());Tcl_AppendElement(interp,erg);
       snprintf(erg,100,"Varianz\t= %g\n",sp->varianz());Tcl_AppendElement(interp,erg);
       snprintf(erg,100,"Steuung\t= %g\n",sp->streuung());Tcl_AppendElement(interp,erg);
       return TCL_OK;
     }
  else 
  {
    Tcl_AppendResult(interp,"bad command ",argv[1],(char *)NULL);
    return TCL_ERROR;
  }
  return TCL_OK;
}

void  DeleteStat(ClientData cldat)
{
  delete (Stat *)cldat;
}


