#include"NDichte.h"
#include<sstream>
#include<math.h>
#include<stdexcept>
#include<string>

extern "C" Dichte *erzeugeDichte(const char *sig)
{
   std::istringstream istr(sig);
   double mue,sigma;
   char c[2];
   istr >> c[0];  
   istr >> c[1];  
   
   c[2]='\0';
   if(c[0]!='N' || c[1]!='(') 
   {
       throw std::invalid_argument(std::string(sig)+" ist keine NormalVerteilung N(mue,sigma)");
   }
   istr >> mue;
   char in;
   istr >> in;
   if(in!=',') throw std::invalid_argument(std::string(sig)+": Komma erwartet nach mue");
   istr >> sigma;
   istr >> in;
   if(in!=')') throw std::invalid_argument(std::string(sig)+": ')' am Ende erwartet "); 
   return new NDichte(mue,sigma);
}

NDichte::NDichte(double mue,double sigma):mue_(mue),sigma_(sigma)
{
    fak_=1.0/(sqrt(2*M_PI)*sigma_);
    efak_ = -1.0/(2*sigma_*sigma_);
}

double NDichte::operator()(double x)
{
   double xmmue = x-mue_;
   return fak_*exp(efak_*xmmue*xmmue);
}
